<casemodal>
    <link type="text/css" rel="stylesheet" href="assets/styles/modal.css">
    <style>
        .modal-body {
            height: 600px;
        }
        textarea {
            resize: none;
            height: 150px;
            font-size: 16px;
        }
        .scroll {
            overflow: auto;
            height: 300px;
        }
        .margin-t {
            margin-top: 15px;
        }
        .detail {
        }
        .right {
            text-align: right;
            float: right;
            clear: both;
            margin-right: 15px;
        }
        .right .content {
            color: #fff;
            background-color: #305F72 ;
        }
        .left {
            text-align: left;
            float: left;
            clear: both;
            margin-left: 15px;
        }
        .left .content {
            background-color: #eee;
        }
        .content {
            padding: 5px 10px;
            border-radius: 5px;
            width: fit-content;
            text-align: left !important;
        }
        .path {
            font-size: 12px;
        }
        .mb-10 {
            margin-bottom: 10px;
        }
        .mr-0 {
            margin-right: 0;
        }
        .ml-a {
            margin-left: auto;
        }
        .path-link {
            color: #2196f3 !important;
            text-decoration: underline !important;
        }
        #file-label {
            padding: 5px 20px;
            background-color: silver;
            cursor: pointer;
            border-radius: 5px;
            transition: .3s;
            margin-right: 10px;
        }
        #file-label:hover {
            opacity: 0.8;
        }
        input[type="file"] {
            display: none;
        }
    </style>
    <div id="caseModal" class="modal fade" role="dialog">
        <div class="modal-dialog modal-lg">
            <!-- Modal content-->
            <div class="modal-content">
                <div class="modal-header">
                    <div id="title">{title}</div>
                </div>
                <div class="modal-body">
                    <div class="text-right">
                        <button onclick="{ onSelectTemplateClick }" class="bdt-button buttons-create btn btn-nc">文章挿入</button>
                    </div>
                    <div class="form-group margin-t">
                        <label>返信内容</label>
                        <textarea id="content" name="content" class="form-control"></textarea>
<!--                        <input type="file" id="file" name="file" onchange="{onFileChange}"/>-->

                        <label id="file-label" for="form-image">画像選択</label>
                        <input type="file" id="form-image">
                        <span class="select-image">画像なし</span>

                    </div>
                    <div class="scroll">
                        <div class="support" each="{detail in details}">
                            <span class="{detail.type == 1 ? 'left' : 'right'}">{detail.updatedAtFormatted }</span>
                            <div class="detail {detail.type == 1 ? 'left' : 'right'}">
                                <div class="content {detail.path ? '' : 'mb-10'} {detail.type != 1 && detail.path ? 'ml-a mr-0' : ''}">
                                    <casemodalcontent content="{detail.content}"/>
                                </div>
                                <div class="path mb-10" if="{detail.path}">
                                    <span class="glyphicon glyphicon-paperclip"></span>
                                    <a href="{'https://' + detail.path}" target="_blank" class="path-link">{detail.path.split('/')[detail.path.split('/').length-1]}</a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <div id="btn-group" class="btn-gr pull-right">
                        <button onclick="{ onCloseClick }" class="bdt-button buttons-create btn btn-nc">閉じる</button>
                        <button onclick="{ onSubmitClick }" class="bdt-button buttons-create btn btn-nc">送信</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <answertemplate />
    <script>
        export default {
            async onBeforeMount(props, state) {
                moment.locale('ja')
                this.caseService = new CaseService()
                this.mailService = new MailService()
                this.caseId = props.caseId
                this.email = props.email
                this.datatable = props.datatable
                this.editor = this.datatable._editor
                this.createFlg = false
                this.file = null
                this.base64 = null
            },
            async onMounted(props, state) {
                const self = this
                this.cases = []
                const response = await this.caseService.search("", "", props.caseId, false)
                if (response.statusCode != 200) {
                    toastr.error(response.message)
                    return
                }
                this.cases = response.data
                this.case = this.cases.find(function (cs) {
                    return cs.type == 0
                })
                this.title = this.case.content
                this.assetId = this.case.assetId
                this.details = this.cases.filter(function (cs) {
                    return cs.type > 0
                })
                this.details = _.sortBy( self.details,'updatedAt').reverse()
                this.details.forEach(detail => {
                    detail.content = detail.content.replace(/\n/g, '<br>')
                    detail.updatedAtFormatted = moment(detail.updatedAt).format('M/DD (dd) HH:mm:ss')
                })
                self.update()
                $('#caseModal').on('hidden.bs.modal', function () {
                    if (self.createFlg) {
                        self.datatable.api().ajax.reload()
                        self.createFlg = false
                    }
                })

                // 端末情報取得
                this.assetService = new AssetService()
                const assetItems = await this.assetService.get(this.assetId)
                if (assetItems.statusCode != 200) {
                    toastr.error(assetItems.message)
                    return
                }
                this.asset = assetItems.data[0]

                $('input').on('change', (e) => {
                    this.onFileChange(e.target.files[0])
                });
            },
            onCloseClick() {
                $('#caseModal').modal('hide')
            },
            async onSubmitClick() {
                const content = this.$('textarea').value
                if (!content) return
                const updatedAt = moment().format('YYYY-MM-DD HH:mm:ss')

                // 件名を登録
                const data = {
                    caseId: this.caseId,
                    updatedAt: updatedAt,
                    assetId: this.assetId,
                    email: this.email,
                    content: content,
                    status: 0,
                    type: 2
                }
                if (this.file) {
                    data.fileName = this.file.name
                    data.fileType = this.file.type
                    data.base64 = this.base64
                }
                const response = await this.caseService.create(data)
                if (response.statusCode != 200) {
                    toastr.error(response.message)
                    return
                }
                $('#file').val('')
                this.file = null

                this.$('textarea').value = ''
                await this.getDetail()
                this.createFlg = true
                await this.updateStatus(1, updatedAt)

                // メール送信はしない
                // if (!this.asset.contactEmail) return
                // const param = {
                //     to: this.asset.contactEmail,
                //     content: MailContent.SUPPORT_REPLY.content.replace('${name}', this.asset.userName).replace('${content}', content),
                //     subject: MailContent.SUPPORT_REPLY.subject.replace('${subject}', this.title)
                // }
                // await this.mailService.send(param)

            },
            async updateStatus(status, updatedAt) {
                const data = this.case
                data.status = status
                data.email = this.email
                if (updatedAt) {
                    data.updatedAt = updatedAt
                } else {
                    data.updatedAt = moment().format('YYYY-MM-DD HH:mm:ss')
                }
                const response = await this.caseService.update(data)
                if (response.statusCode != 200) {
                    toastr.error(response.message)
                }
            },
            async getDetail() {
                const self = this
                const response = await this.caseService.search(this.email, "", this.caseId, false)
                if (response.statusCode != 200) {
                    toastr.error(response.message)
                    return
                }
                self.details = []
                self.update()
                self.details = response.data.filter(function (detail) {
                    return detail.type > 0
                })
                self.details = _.sortBy( self.details,'updatedAt').reverse()
                // 改行対応
                self.details.forEach(detail => {
                    detail.content = detail.content.replace(/\n/g, '<br>')
                    detail.updatedAtFormatted = moment(detail.updatedAt).format('M/DD (dd) HH:mm:ss')
                })
                self.update()
            },
            show() {
                $('#caseModal').modal()
            },
            onFileChange(file) {
                this.file = file
                if (!this.file) return

                if (this.file.type.indexOf('jpg') < 0 && this.file.type.indexOf('jpeg') < 0 && this.file.type.indexOf('png') < 0) {
                    toastr.warning('画像ファイルの拡張子が正しくありません')
                    return
                }

                $('.select-image').text(file.name);

                const fileReader = new FileReader()
                fileReader.readAsDataURL(this.file)
                fileReader.onload = () => {
                    this.base64 = fileReader.result
                }
            },
            onSelectTemplateClick() {
                const modal = riot.mount('answertemplate', {}, 'answertemplatemodal')[0]
                modal.show()
            }
        }
    </script>
</casemodal>
